;	Playground Sprite
;	By: Hazy, you choose (explained below)
;	Basically, I (HuFlungDu) took White Yoshi Egg's playground idea from A Strange Mission and
;	recreated it in a sprite form that was easy to use and actually allowed you to see what
;	you were going to place. This is why it is hazy who is the "author" of this sprite
;	I don't really care, so you can think either White Yoshi Egg or I, doesn't really matter.
;	In case you never played/beat A Strange Mission, this will allow you to choose a map16
;	tile to place at any point in the level. If you sitll don't understand, video description here:
;	http://www.youtube.com/watch?v=C8o0UstEML0
;	Use L to change which object you want to place then press R to place it, it's that simple. 
;	I would however suggest that you also apply the
;	L/R hook patch if you are going to use this, as it could get kinda awkward.
;	I'm sure someone can think of some awesome puzzles to make out of this.
;	MUST be assembled with Romi's sprite tool as it assembles with Xkas because I was too lazy
;	to iron out the errors it threw when I assembled with TRASM. Insert as a generator.
;	No Credit necessary



!freeram = $0660		;Epicly overused freeram, Change it or you will likely have problems
!numblocks = $06		;This is the number of blocks you allow the user to spawn

print "INIT ",pc
RTL
BlockTableHigh:					;High byte of map16 tile to spawn
db $02,$25,$12,$1E,$2E,$30,$32

BlockTableLow:					;Low byte of map16 tile to spawn
db $00,$00,$01,$01,$01,$01,$01

;To use, place the high byte in the top table
;then the low byte in the corresponding place
;in the bottom table. e.g. block 115 would add
;$15 to the top table and $01 to the bottom table

BlockNames:
Water:
db $20,$0A,$1D,$0E,$1B,$FC,$FF
Blank:
db $0B,$15,$0A,$17,$14,$FC,$FF
OnOff:
db $18,$17,$FC,$18,$0F,$0F,$FF
Turn:
db $1D,$1E,$1B,$17,$24,$0B,$FF
Grab:
db $10,$1B,$0A,$0B,$24,$0B,$FF
Cement:
db $0C,$0E,$16,$0E,$17,$1D,$FF
Brown:
db $1E,$1C,$0E,$0D,$24,$0B,$FF

;These are the tile that make up the names
;that go in the status bar. They should all 
;be around the same length, though that's not required.
;However, each table does have to end with a $FF or else 
;the game will put that name and the one after it in the 
;status bar.

WordTablePointers:
dw Water
dw Blank
dw OnOff
dw Turn
dw Grab
dw Cement
dw Brown

;This is just the pointers. There's one for every name you
;put in the above tables, add these in the order you have
;the block tables. So if you added block 24 in position three 
;of the original block table, you would put it's name pointer
;in position three here. The order of the table of names itself
;is inconsequential.

print "MAIN ",pc
PHB							;\
PHK							;| Push the data bank
PLB							;/
LDA  !freeram				;\ Check which block you are on
CLC							;| And multiply by 2 so we can
ADC !freeram				;/ read from the pointer table
PHX
TAX							; Transfer the Accumulator to the X register
REP #$20					; Enter 16bit mode
LDA WordTablePointers,x		;\ get what address you are supposed
STA $00						;/ to load from
SEP #$20					; Exit 16bit mode
PLX
LDY #$00					; initialize the accumulator for the loop
WordLoop:
LDA ($00),y					; Load the value from the address stored earlier
CMP #$FF					;\ If it's FF, then it's the end of the table
BEQ endloop					;/ (this is why you need to end name table with FF)
STA $0F09,y					; display in the status bar
INY							;\ and move on
BRA WordLoop				;/
endloop:
LDA $18						;\ Check if L is pressed
AND #$20					;| If not, skip the code
BEQ rolld					;/ to change your selected block 
LDA !freeram				;\ Check if the freeram is less than
CMP #!numblocks				;| the number of blocks you allowed
BCC notroll					;/ if it is, then don't roll it over
STZ !freeram				;\ Reset freeram
JMP rolld					;/ and don't increase it
notroll:
INC !freeram				; Increase the block number
rolld:
LDA $18						;\Check if R is pressed
AND #$10					;|
BEQ return					;/
LDY !freeram				;\ Get which block to spawn
LDA BlockTableLow,y			;| based on freeram
XBA							;|
LDA BlockTableHigh,y		;/
PHX
REP #$30					;\ Enter 16bit mode
TAX							;| Transfer Accumulator to X register
JSR ChangeMap16				;| And spawn a tile
SEP #$30					;/ Then exit 16bit mode
PLX
return:
PLB							; the rest of the data bank thing found at the beginning
RTL							; Return


; Almost everything below here was written by either FuSoYa or spel werdz rite
; it's the normal way to change a map 16 number. As I didn't write it, I don't really understand
; it that much, so it's not commented on, but you don't need to understand this to use it


PrematureEnd:
PLX
PLY
PLB
PLP
RTS
ChangeMap16:
PHP
SEP #$20
PHB
PHY
LDA #$00
PHA
PLB
REP #$30
PHX
LDA $9A
AND #$FFF0
STA $0C
LDA $98
AND #$FFF0
STA $0E
LDA #$0000
SEP #$20
LDA $5B
STA $09
LDA $1933
BEQ SkipShift
LSR $09
SkipShift:
LDY $0E
LDA $09
AND #$01
BEQ LeaveXY
LDA $9B
STA $00
LDA $99
STA $9B
LDA $00
STA $99
LDY $0C
LeaveXY:
CPY #$0200
BCS PrematureEnd
LDA $1933
ASL A
TAX
LDA $BEA8,x
STA $65
LDA $BEA9,x
STA $66
STZ $67
LDA $1925
ASL A
TAY
LDA [$65],y
STA $04
INY
LDA [$65],y
STA $05
STZ $06
LDA $9B
STA $07
ASL A
CLC
ADC $07
TAY
LDA [$04],y
STA $6B
STA $6E
INY
LDA [$04],y
STA $6C
STA $6F
LDA #$7E
STA $6D
INC A
STA $70
LDA $09
AND #$01
BEQ SwitchXY
LDA $99		
LSR A
LDA $9B
AND #$01
BRA CurrentXY
SwitchXY:
LDA $9B
LSR A
LDA $99
CurrentXY:
ROL A
ASL A
ASL A
ORA #$20
STA $04
CPX #$0000
BEQ NoAdd
CLC
ADC #$10
STA $04
NoAdd:
LDA $98
AND #$F0
CLC
ASL A
ROL A
STA $05
ROL A
AND #$03
ORA $04
STA $06
LDA $9A
AND #$F0
REP 3 : LSR A
STA $04
LDA $05
AND #$C0
ORA $04
STA $07
REP #$20
LDA $09
AND #$0001
BNE LayerSwitch
LDA $1A
SEC
SBC #$0080
TAX
LDY $1C
LDA $1933
BEQ CurrentLayer
LDX $1E
LDA $20
SEC
SBC #$0080
TAY
BRA CurrentLayer
LayerSwitch: 
LDX $1A
LDA $1C
SEC
SBC #$0080
TAY
LDA $1933
BEQ CurrentLayer
LDA $1E
SEC
SBC #$0080
TAX
LDY $20
CurrentLayer:
STX $08
STY $0A
LDA $98
AND #$01F0
STA $04
LDA $9A
REP 4 : LSR A
AND #$000F
ORA $04
TAY
PLA
SEP #$20
STA [$6B],y
XBA
STA [$6E],y
XBA
REP #$20
ASL A
TAY
PHK
PER $0006
PEA $804C
JML $00C0FB
PLY
PLB
PLP
RTS
RTL